Backport:  

Description

=begin

SSL_CTX_sess_set_new_cb で渡すコールバックの返り値は、

「0 を返すと新しく作られた SSL_SESSION のリファレンスカウンタの

値を減らし(て SSL_SESSION を解放し）、

それ以外を返すとリファレンスカウンタを減らさない」となっています。

しかし、ext/openssl/ossl_ssl.c:ossl_sslctx_session_new_cb ではその中で

リファレンスカウンタの値を増やしているにもかかわらず1を返す場合があります。

ここは常に0を返すべきではないでしょうか？

=end

Associated revisions

Revision dea3113a - 06/22/2011 01:39 PM - Hiroshi Nakamura 

ext/openssl/ossl_ssl.c (ossl_sslctx_session_new_cb): Return 0 to

OpenSSL from the callback for SSL_CTX_sess_set_get_cb().

Returning 0 means to OpenSSL that the the session is still valid

(since we created Ruby Session object) and was not freed by us with

SSL_SESSION_free(). Call SSLContext#remove_session(sess) in

session_get_cb block if you don't want OpenSSL to cache the session

internally.

This potential issue was pointed by Ippei Obayashi. See #4416.

test/openssl/test_ssl_session.rb (test_ctx_server_session_cb): Test

it.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32204 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/22/2011 09:43 AM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to nahi (Hiroshi Nakamura)

=begin

=end

#2 - 06/22/2011 05:21 PM - nahi (Hiroshi Nakamura)

この参照追加はRubyオブジェクトからの参照で、Rubyオブジェクトの開放時にSSL_SESSION_freeを呼ぶために必要なんですが、逆に0（Rubyレベルでfalse）を返したときのOpenSSLの挙動がよくわかりませ

んね。。。うーむ。

#3 - 06/22/2011 10:53 PM - nahi (Hiroshi Nakamura)

- Status changed from Assigned to Closed

- Target version changed from 1.9.2 to 1.9.3
r32204で、ご提案いただいたとおりの修正を入れました。Rubyオブジェクトからの参照があり、OpenSSLに何を返しても、session_new_cbに渡されたセッションはクリアされないのですから、0や1を返し分けても無

意味、なので、OpenSSL側での整合性を取るために、常に0を返して参照数を適切に調整すべき、ということですね。やっと理解しました。ありがとうございました。

結果として、session_new_cbのコールバックについて、「返す値に意味はない」という変更になりましたが、もとよりバグですので、修正として扱おうと思います。ドキュメントに影響が出てしまい恐縮です。
